from datetime import datetime

from cpl_core.database import TableABC

from bot_data.model.realm import Realm
from bot_data.model.user import User


class RealmModerator(TableABC):
    def __init__(
        self,
        realm: Realm,
        user: User,
        created_at: datetime = None,
        modified_at: datetime = None,
        id=0,
    ):
        self._join_id = id
        self._realm = realm
        self._user = user

        TableABC.__init__(self)
        self._created_at = created_at if created_at is not None else self._created_at
        self._modified_at = modified_at if modified_at is not None else self._modified_at

    @property
    def id(self) -> int:
        return self._join_id

    @property
    def realm(self) -> Realm:
        return self._realm

    @property
    def user(self) -> User:
        return self._user

    @staticmethod
    def get_select_all_string() -> str:
        return str(
            f"""
            SELECT * FROM `RealmModerators`;
        """
        )

    @staticmethod
    def get_select_by_id_string(id: int) -> str:
        return str(
            f"""
            SELECT * FROM `RealmModerators`
            WHERE `Id` = {id};
        """
        )

    @staticmethod
    def get_select_by_realm_id_string(id: int) -> str:
        return str(
            f"""
            SELECT * FROM `RealmModerators`
            WHERE `RealmId` = {id};
        """
        )

    @staticmethod
    def get_select_by_user_id_string(id: int) -> str:
        return str(
            f"""
            SELECT * FROM `RealmModerators`
            WHERE `UserId` = {id};
        """
        )

    @property
    def insert_string(self) -> str:
        return str(
            f"""
            INSERT INTO `RealmModerators` (
                `UserId`, `RealmId`
            ) VALUES (
                {self._user.id},
                {self._realm.id}
            );
        """
        )

    @property
    def udpate_string(self) -> str:
        return str(f"""""")

    @property
    def delete_string(self) -> str:
        return str(
            f"""
            DELETE FROM `RealmModerators`
            WHERE `Id` = {self._join_id};
        """
        )

    @staticmethod
    def delete_by_user_id_string(id: int) -> str:
        return str(
            f"""
            DELETE FROM `RealmModerators`
            WHERE `UserId` = {id}
    """
        )
