from bot_data.abc.history_table_abc import HistoryTableABC
from bot_data.model.realm import Realm
from bot_data.model.user import User


class RealmModerator(HistoryTableABC):
    def __init__(
        self,
        realm: Realm,
        user: User,
        deleted: bool,
        date_from: str,
        date_to: str,
        id=0,
    ):
        HistoryTableABC.__init__(self)

        self._join_id = id
        self._realm = realm
        self._user = user

        self._deleted = deleted
        self._date_from = date_from
        self._date_to = date_to

    @property
    def id(self) -> int:
        return self._join_id

    @property
    def realm(self) -> Realm:
        return self._realm

    @property
    def user(self) -> User:
        return self._user
