import discord
from cpl_core.logging import LoggerABC
from cpl_discord.events import OnMemberUpdateABC
from cpl_discord.service import DiscordBotServiceABC

from bot_core.service.permission_service_with_cache import PermissionServiceWithCache


class BaseOnMemberUpdateEvent(OnMemberUpdateABC):
    def __init__(
        self,
        logger: LoggerABC,
        bot: DiscordBotServiceABC,
        permissions: PermissionServiceWithCache,
    ):
        OnMemberUpdateABC.__init__(self)

        self._logger = logger
        self._bot = bot
        self._permissions = permissions

    async def on_member_update(self, before: discord.member.Member, after: discord.member.Member):
        if before.roles != after.roles:
            self._permissions.reset_cache()
